/*! \file OptionChar.h 
 *  \brief: header file for optionschar object
 */

#ifndef _OPTIONSCHAR_H_
#define _OPTIONSCHAR_H_

/*Headers:{{{1*/
#include "../../include/include.h"
#include "../../shared/Exceptions/exceptions.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

#include "./Option.h"
/*}}}*/

class OptionChar: public Option {

	public:

		char* values;

		/*OptionChar constructors, destructors {{{1*/
		OptionChar();
		~OptionChar();
		/*}}}*/
		/*Object virtual functions definitions:{{{1*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		int   Id(){_error_("Not implemented yet");};
		int   MyRank(){_error_("Not implemented yet");};
		void  Marshall(char** pmarshalled_dataset){_error_("Not implemented yet");};
		int   MarshallSize(){_error_("Not implemented yet");};
		void  Demarshall(char** pmarshalled_dataset){_error_("Not implemented yet");};
		int   Enum(){return OptionCharEnum;};
		Object* copy(){_error_("Not implemented yet");};
		/*}}}*/

		/*virtual functions: */
		char* Name();
		int   NumEl();
		int   NDims();
		int*  Size();
		void  Get(double* pvalue){_error_("An OptionChar object cannot return a double");};
		void  Get(bool* pvalue){  _error_("An OptionChar object cannot return a bool");};
		void  Get(char** pvalue);

};
#endif  /* _OPTIONSCHAR_H */

