/*! \file OptionDouble.h 
 *  \brief: header file for optionsdouble object
 */

#ifndef _OPTIONSDOUBLE_H_
#define _OPTIONSDOUBLE_H_

/*Headers:{{{1*/
#include "../../include/include.h"
#include "../../shared/Exceptions/exceptions.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

#include "./Option.h"
/*}}}*/

class OptionDouble: public Option {

	public:

		double* values;

		/*OptionDouble constructors, destructors {{{1*/
		OptionDouble();
		~OptionDouble();
		/*}}}*/
		/*Object virtual functions definitions:{{{1*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		int   Id(){_error_("Not implemented yet");};
		int   MyRank(){_error_("Not implemented yet");};
		void  Marshall(char** pmarshalled_dataset){_error_("Not implemented yet");};
		int   MarshallSize(){_error_("Not implemented yet");};
		void  Demarshall(char** pmarshalled_dataset){_error_("Not implemented yet");};
		int   Enum(){return OptionDoubleEnum;};
		Object* copy(){_error_("Not implemented yet");};
		/*}}}*/

		/*virtual functions: */
		char* Name();
		int   NumEl();
		int   NDims();
		int*  Size();
		void  Get(double* pvalue);
		void  Get(bool* pvalue){  _error_("An OptionDouble object cannot return a bool");};
		void  Get(char** pvalue){ _error_("An OptionDouble object cannot return a string");};

};
#endif  /* _OPTIONSDOUBLE_H */

